﻿Public Class Form1
    ' 用紙への印刷かどうかのフラグ
    Dim IsPrint As Boolean = False

    ' フォームのロード処理
    Private Sub Form1_Load(ByVal sender As System.Object, _
                           ByVal e As System.EventArgs) Handles MyBase.Load
        With PrintDocument1.DefaultPageSettings.Margins
            .Left = 20 / 0.254
            .Top = 20 / 0.254
            .Right = 20 / 0.254
            .Bottom = 20 / 0.254
        End With
        PrintDocument1.DocumentName = "PrintDocumentのサンプルコード"
        PrintDocument1.OriginAtMargins = False
    End Sub

    ' ページ設定ボタンの押下処理
    Private Sub Button1_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button1.Click
        PageSetupDialog1.EnableMetric = True
        PageSetupDialog1.Document = PrintDocument1
        With PrintDocument1.DefaultPageSettings
            PageSetupDialog1.MinMargins.Left = .PrintableArea.X
            PageSetupDialog1.MinMargins.Top = .PrintableArea.Y
            PageSetupDialog1.MinMargins.Right = _
                    .PaperSize.Width - .PrintableArea.Width - .PrintableArea.X
            PageSetupDialog1.MinMargins.Bottom = _
                    .PaperSize.Height - .PrintableArea.Height - .PrintableArea.Y
        End With
        PageSetupDialog1.ShowDialog()
    End Sub

    ' 印刷ボタンの押下処理
    Private Sub Button2_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button2.Click
        PrintDialog1.Document = PrintDocument1
        PrintDialog1.AllowPrintToFile = False
        Dim result As DialogResult
        result = PrintDialog1.ShowDialog()
        If result = Windows.Forms.DialogResult.OK Then
            IsPrint = True
            PrintDocument1.Print()
        End If
    End Sub

    ' 印刷プレビューボタンの押下処理
    Private Sub Button3_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) Handles Button3.Click
        With PrintPreviewDialog1
            .Document = PrintDocument1
            .UseAntiAlias = True
        End With
        IsPrint = False
        PrintPreviewDialog1.ShowDialog()
    End Sub

    ' 印刷処理
    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, _
                            ByVal e As System.Drawing.Printing.PrintPageEventArgs) _
                        Handles PrintDocument1.PrintPage
        With PrintDocument1.DefaultPageSettings
            If IsPrint Then
                If PrintDocument1.OriginAtMargins Then
                    e.Graphics.TranslateTransform(.Margins.Left * -1, .Margins.Top * -1)
                Else
                    e.Graphics.TranslateTransform(.HardMarginX * -1, .HardMarginY * -1)
                End If
            Else
                If PrintDocument1.OriginAtMargins Then
                    e.Graphics.TranslateTransform((.Margins.Left - .HardMarginX) * -1, _
                                                  (.Margins.Top - .HardMarginY) * -1)
                End If
            End If
        End With

        Static data As String = Nothing
        If data Is Nothing Then
            data = TextBox1.Text
        End If
        Dim textLength, textLine As Integer
        e.Graphics.MeasureString(data, _
                                 New Font("ＭＳ ゴシック", 10), _
                                 e.MarginBounds.Size, _
                                 StringFormat.GenericTypographic, _
                                 textLength, textLine)
        e.Graphics.DrawString(data.Substring(0, textLength), _
                              New Font("ＭＳ ゴシック", 10), _
                              Brushes.Black, _
                              e.MarginBounds, _
                              StringFormat.GenericTypographic)
        data = data.Substring(textLength)
        If data.Length > 0 Then
            e.HasMorePages = True
        Else
            e.HasMorePages = False
            data = Nothing
        End If
    End Sub
End Class
